import java.applet.*;
import java.util.*;

public class BGMPlayer extends Applet implements Runnable{
    
    Hashtable sounds;
    boolean loopBGM;
    Thread thread;
    Vector vector;
    AudioClip ac;
    
    public void init(){
        sounds = new Hashtable();
        StringTokenizer st = new StringTokenizer(getParameter("sound"));
        while(st.hasMoreTokens()){
            String s = st.nextToken();
            sounds.put(s,getAudioClip(getCodeBase(),st.nextToken()));
        }
        thread = null;
        vector = null;
        ac = null;
    }
    
    public void play(String string,boolean loopBGM){
        this.loopBGM = loopBGM;
        vector = new Vector();
        StringBuffer sb = null;
        for(int i = 0;i < string.length();i++){
            if(Character.isDigit(string.charAt(i))){
                sb.append(string.charAt(i));
            }else{
                if(sb != null){
                    vector.addElement(new Integer(sb.toString()));
                }
                vector.addElement(sounds.get(new Character(string.charAt(i)).toString()));
                sb = new StringBuffer();
            }
        }
        vector.addElement(new Integer(sb.toString()));
        thread = new Thread(this);
        thread.setDaemon(true);
        thread.start();
    }
    
    public void stopPlay(){
        thread.stop();
        thread = null;
        ac.stop();
    }
    
    public boolean isPlaying(){
        return (thread != null);
    }
    
    public void run(){
        try{
            while(loopBGM){
                for(int i = 0;i < vector.size() / 2;i++){
                    ac = (AudioClip)vector.elementAt(i * 2);
                    ac.loop();
                    Thread.sleep(((Integer)vector.elementAt((i * 2)+ 1)).intValue());
                    ac.stop();
                }
            }
        }catch(InterruptedException ie){
            System.err.println(ie);
        }
    }
}